--- vorbis-tools-1.0beta3/ogg123/ogg123.c.defaultdevice	Sat Nov  4 07:23:21 2000
+++ vorbis-tools-1.0beta3/ogg123/ogg123.c	Wed Nov  8 21:30:14 2000
@@ -175,6 +175,12 @@
 	char filename[NAME_MAX];
 	char line[100];
 	char *device = NULL;
+	char *devices[] = {
+		NULL,
+		"esd",
+		"oss"
+	};
+	const int num_devices = sizeof (devices) / sizeof (devices[0]);
 	int i;
 
 	strncpy(filename, getenv("HOME"), NAME_MAX);
@@ -193,7 +199,13 @@
 		fclose(fp);
 	}
 
-	if (device) return ao_get_driver_id(device);
+	devices[0] = device;
+
+	for (i=0; i<num_devices; i++) {
+		int id=ao_get_driver_id(devices[i]);
+		if (i>0)
+			return id;
+	}
 
 	return -1;
 }
@@ -207,6 +219,7 @@
   int option_index = 1;
   ao_option_t *temp_options = NULL;
   int temp_driver_id = -1;
+  int driver_chosen = 0;
   devices *current;
   int bits, rate, channels;
 
@@ -226,11 +239,12 @@
 	case 'd':
 	  /* Need to store previous device before gathering options for
 	     this device */
-	  if (temp_driver_id != -1)
+	  if (driver_chosen)
 	    {
 	      append_device(&param.outdevices, temp_driver_id, temp_options);
 	      temp_options = NULL;
 	    }
+	  driver_chosen = 1;
 	  temp_driver_id = ao_get_driver_id(optarg);
 	  if (temp_driver_id < 0)
 	    {
